<!doctype html><html lang=en><title>Visual Studio下开发Linux程序 - L.E.R Space</title><meta charset=utf-8><meta name=viewport content="width=device-width,initial-scale=1,maximum-scale=1,user-scalable=no"><meta http-equiv=x-ua-compatible content="IE=edge"><meta name=Keywords content="LER0ever,L.E.R,荣懿,Yi Rong,rongyi,blog,博客,L.E.R Space,etasry,Portus"><meta name=Description content="配置Visual Studio以更方便的在Windows下开发Linux程序"><link rel=manifest href=/manifest.json><link rel="shortcut icon" href=/favicon.ico><script>
if (self != top) {
  top.location=this.location.href;
}
</script><link rel=stylesheet href=/css/bundle.css><link rel=stylesheet href=/css/hody-icons.css><link rel=stylesheet href=/css/hljs-dracula.css><link rel=stylesheet href=/css/style.css><link rel=stylesheet href=/fonts/fonts.css><link rel=stylesheet href=/search/css/search.css><div id=loader><div class=centrize><div class=v-center><div id=mask><svg class="preloader-icon" width="34" height="38" viewbox="0 0 34 38"><path class="preloader-path" stroke-dashoffset="0" d="M29.437 8.114 19.35 2.132c-1.473-.86-3.207-.86-4.68.0L4.153 8.114C2.68 8.974 1.5 10.56 1.5 12.28v11.964c0 1.718 1.22 3.306 2.69 4.165l10.404 5.98c1.47.86 3.362.86 4.834.0l9.97-5.98c1.472-.86 2.102-2.45 2.102-4.168V12.28c0-1.72-.59-3.306-2.063-4.166z"/></svg></div></div></div></div><div id=wrapper><nav id=navbar><div class=navbar-wrapper><div class=container><div class=logo><a href=/><h2 class=logo-text>L.E.R Space</h2></a></div><div class=menu-extras><div class=menu-item><div class=open-search-form><a href id=searchbtn><i class=hc-search></i></a></div></div><div class=menu-item><div class=nav-toggle><a class=menu-toggle href=#><div class=hamburger><div class=hamburger-box><div class=hamburger-inner></div></div></div></a></div></div></div><div id=navigation><ul class="navigation-menu nav"><li class=menu-item><a href=/>主页</a><li class=menu-item><a href=/about>关于我</a><li class=menu-item><a href=/blog>博客</a><li class=menu-item><a href=/links>链接</a><li class=menu-item><a href=/contact>联系</a><li class=menu-item><a href=/projects>软件</a><li class=menu-item><a href=/cos>图像后期</a><li class=menu-item><a href=/sheets>乐谱分享</a><li class=menu-item><a href=/archive>归档</a><li class="menu-item-has-children last-elements"><a href=/en target=_blank><i class=hc-globe></i></a><ul class=submenu><li><a href=/ target=_blank>简体中文</a><li><a href=/en target=_blank>English</a></ul></ul></div></div></div></nav><section class="page-title parallax-section"><div class=row-parallax-bg><div class=parallax-wrapper><div class=parallax-bg><img src=/media/posts/macandnotebook.jpg alt></div></div><div class=parallax-overlay></div></div><div class=centrize><div class=v-center><div class=container><div class=single-post-info><h6><span><i class=hc-clock></i>Posted on</span>
<span class=post-time>February 19, 2018</span>
<span>in <a href=/category/%e5%bc%80%e5%8f%91%e7%8e%af%e5%a2%83.html>开发环境</a></span></h6><div class="title text-center"><h1>Visual Studio下开发Linux程序</h1></div><div class=post-author><img src=/media/author.jpg alt><a href=#>by LER0ever</a></div></div></div></div></div></section><section><div class=container><div class=row><div class=col-md-8><article class=post-single><div class=post-body><h3 id=起因>起因</h3><p>最近因为CS537操作系统课程的原因，经常需要开发Unix下的小应用程序，比如实现个Shell啊什么的。
我目前的桌面台式机是同时装了Windows(10), Linux(两个发行版), macOS(黑苹果)三个操作系统的，并且都是实体安装，
这就导致Windows下办公完了想去Linux下写写程序就需要重启。而在去年的时候微软宣布他们的Visual Studio支持开发Linux的应用程序了，所以觉得我也折腾一把之后或许会方便一些。</p><h3 id=原料>原料</h3><p>这个特性貌似是Visual Studio 2017 15.4才加进来的特性，所以各位没装的或者旧版本的可能需要升级才可以使用这个功能。<h3 id=尝试新建linux-console项目>尝试新建Linux Console项目</h3><p><img src=/media/post/20180219-linux-programming-with-vs/linux-proj-tmpl.jpg alt>
输入项目名称，文件夹路径，选Linux Console Application，点完成<br>之后就可以按照正常的Visual Studio项目配置过程来配置Linux项目了。<p>微软远程编译、调试的原理就是在本地生成CMakeCache以及Unix Makefile，然后将源码和构建脚本直接复制到Linux机器上远程调用编译器编译。
这个过程是单向的，本地源码永远是最新，远程工作目录每次编译的时候更新一次，然后Visual Studio根据本地的CMakeCache来了解这个项目。<br>于是就可以在<del>全宇宙最好用的IDE</del> Visual Studio 下写这个菜的抠脚的操作系统课作业了。<hr><p><strong>以为这样就完了？Windows才不会让你这么轻易的解决问题&hellip;</strong><p>微软家的编译器和所有IDE配套工具链都有个共同的问题，<strong>分不清C和C++</strong>，根本原因就是自家的cl.exe同时支持C/C++编译并且不作分开处理。
然后在项目配置里有两个选项直接致命，第一个是<code>-frtti</code>，另一个是<code>-fno-strict-aliasing</code>两个在GCC上都是C++-only的选项。
而我们的教授要求我们用<code>-Wall -Werror</code>编译程序，所以这两个warning直接报错:(<p>然后尝试自定义命令行参数，或者覆盖之前的参数，然后查文档发现Visual Studio自然是不支持覆盖编译参数的，至少在Linux项目里不行。<p>不过意外地发现Visual Studio 2017引进了CMake支持，并且在2017 15.4的时候支持了Linux的CMake项目，那当然是CMake直接上了<h3 id=尝试打开linux-cmake项目>尝试打开Linux CMake项目</h3><p>CMakeLists：<pre><code class=language-cmake>cmake_minimum_required(VERSION 2.8.9)
project (wish)
SET(CMAKE_C_FLAGS &quot;${CMAKE_C_FLAGS} -Wall -Werror&quot;)
add_executable(wish wish.c)
</code></pre><p>然后配置CMakeSettings然Visual Studio生成对应Cache以及自动连上我宿舍常开的Linux机器远程编译、调试：<pre><code class=language-json>{
  // 请参阅 https://go.microsoft.com//fwlink//?linkid=834763 了解有关此文件的详细信息。
  &quot;configurations&quot;: [
    {
      &quot;name&quot;: &quot;Manjaro-Debug&quot;,
      &quot;generator&quot;: &quot;Unix Makefiles&quot;,
      &quot;remoteMachineName&quot;: &quot;${defaultRemoteMachineName}&quot;,
      &quot;configurationType&quot;: &quot;Debug&quot;,
      &quot;remoteCMakeListsRoot&quot;: &quot;/tmp/src/${workspaceHash}/${name}&quot;,
      &quot;cmakeExecutable&quot;: &quot;/usr/bin/cmake&quot;,
      &quot;buildRoot&quot;: &quot;${env.LOCALAPPDATA}\\CMakeBuilds\\${workspaceHash}\\build\\${name}&quot;,
      &quot;remoteBuildRoot&quot;: &quot;/tmp/build/${workspaceHash}/build/${name}&quot;,
      &quot;remoteCopySources&quot;: true,
      &quot;remoteCopySourcesOutputVerbosity&quot;: &quot;Normal&quot;,
      &quot;remoteCopySourcesConcurrentCopies&quot;: &quot;10&quot;,
      &quot;cmakeCommandArgs&quot;: &quot;&quot;,
      &quot;buildCommandArgs&quot;: &quot;&quot;,
      &quot;ctestCommandArgs&quot;: &quot;&quot;,
      &quot;inheritEnvironments&quot;: [ &quot;linux-x64&quot; ]
    },
    {
      &quot;name&quot;: &quot;Manjaro-Release&quot;,
      &quot;generator&quot;: &quot;Unix Makefiles&quot;,
      &quot;remoteMachineName&quot;: &quot;${defaultRemoteMachineName}&quot;,
      &quot;configurationType&quot;: &quot;Release&quot;,
      &quot;remoteCMakeListsRoot&quot;: &quot;/tmp/src/${workspaceHash}/${name}&quot;,
      &quot;cmakeExecutable&quot;: &quot;/usr/bin/cmake&quot;,
      &quot;buildRoot&quot;: &quot;${env.LOCALAPPDATA}\\CMakeBuilds\\${workspaceHash}\\build\\${name}&quot;,
      &quot;remoteBuildRoot&quot;: &quot;/tmp/build/${workspaceHash}/build/${name}&quot;,
      &quot;remoteCopySources&quot;: true,
      &quot;remoteCopySourcesOutputVerbosity&quot;: &quot;Normal&quot;,
      &quot;remoteCopySourcesConcurrentCopies&quot;: &quot;10&quot;,
      &quot;cmakeCommandArgs&quot;: &quot;&quot;,
      &quot;buildCommandArgs&quot;: &quot;&quot;,
      &quot;ctestCommandArgs&quot;: &quot;&quot;,
      &quot;inheritEnvironments&quot;: [ &quot;linux-x64&quot; ]
    }
  ]
}
</code></pre><p>大概就是如下图所示的配置：
<img src=/media/post/20180219-linux-programming-with-vs/vs-linux-proj-1.jpg alt><p>这时候就可以<strong>完美编译</strong>了，<code>-Wall -Werror</code>也在乐呵呵地向我招手，<strong>远程GDB调试也是完美的</strong>，表扬一下VS的调试器可能是全宇宙最好用的。<hr><p><strong>以为这样就完了？Windows才不会让你这么轻易的解决问题&hellip;</strong><h3 id=intellisense在linux-cmake项目下的补全>Intellisense在Linux CMake项目下的补全</h3><p><strong>是炸的，补不全的。</strong><p>巨硬家的Intellisense依靠理解C/C++的文件依赖关系并且遍历源文件中的函数/变量标记来帮你智能补全。<br>正常写Windows代码的时候这个补全是相当智能的，我在Vim下尝试过多个全功能的补全插件，但是都没有VS家的用得得心应手。<br>但是写Linux程序的时候需要Linux/Unix标准的头文件，没有是没有办法补全的。<br>所以理所当然尝试从隔壁Manjaro复制了一份<code>/usr/include</code>到项目目录，并且配置CppProperties如下：<pre><code class=language-json>{
  &quot;configurations&quot;: [
    {
      &quot;inheritEnvironments&quot;: [
        &quot;x64-Debug&quot;,
        &quot;linux-x64&quot;
      ],
      &quot;name&quot;: &quot;Manjaro-Debug&quot;,
      &quot;includePath&quot;: [
        &quot;D:\\Code\\Wish&quot;,
        &quot;D:\\Code\\Wish\\mjro-include&quot;,
        &quot;D:\\Code\\Wish\\mjro-include\\x86_64-linux-gnu&quot;
      ],
      &quot;defines&quot;: [
        &quot;WIN32&quot;,
        &quot;_DEBUG&quot;,
        &quot;UNICODE&quot;,
        &quot;_UNICODE&quot;
      ],
      &quot;intelliSenseMode&quot;: &quot;linux-gcc-x64&quot;
    }
  ]
}
</code></pre><p>这样Intellisense就可以找到本地的Linux头文件并且提供补全和语法检查了。<hr><p><strong>以为这样就完了？Windows才不会让你这么轻易的解决问题&hellip;</strong><p>Intellisense 根本找不到那些头文件！！！<p><img src=/media/post/20180219-linux-programming-with-vs/vs-linux-proj-2.jpg alt><p>可以看到所有Linux头文件的include以及用到那些头文件的语句都是标红的。<p>这么惊天一个大Bug值得开一个Issue，结果早就有人吃过这坨shi了，<br>Github:Microsoft/VSLinux,
Issue <a href=https://github.com/Microsoft/VSLinux/issues/195>#195</a> 和 <a href=https://github.com/Microsoft/VSLinux/issues/215>#215</a>,
现在仍然没有解决。。。<hr><p><strong>这样就完了？嗯&hellip;这样就完了</strong><p>作业还是要写的，最后一部分由WSL下开Vim完成，至少我配置的补全和检查都是在工作的。<p><img src=/media/post/20180219-linux-programming-with-vs/wsl-evervim.jpg alt><p>Tmux和ssh都在工作，只是需要手动操作了。<p><img src=/media/post/20180219-linux-programming-with-vs/wsl-537-tests.jpg alt><p>微软如果想吸引Linux开发者来用他们的VS写出程序的话，可能还需要好好优化一下VS在这方面的兼容性和易用性。欢迎使用Vim，全宇宙最好的编辑器。</div><hr><div class=post-tags><a href=/tags/Linux.html>Linux</a> <a href=/tags/Visual%20Studio.html>Visual Studio</a></div></article></div><div class="col-md-3 col-md-offset-1"><div id=sidebar><div class=widget><h5>搜索</h5><form class=searchform action=/><input class=form-control type=search required name=s placeholder="Tap or double `Alt` to search ..." id=searchbox></form></div><div class=widget><h5>文章大纲</h5><div class=textwidget><p><a href=#%e8%b5%b7%e5%9b%a0><i class=hc-code-working></i>&nbsp; 起因</a><br><a href=#%e5%8e%9f%e6%96%99><i class=hc-code-working></i>&nbsp; 原料</a><br><a href=#%e5%b0%9d%e8%af%95%e6%96%b0%e5%bb%baLinux%20Console%e9%a1%b9%e7%9b%ae><i class=hc-code-working></i>&nbsp; 尝试新建Linux Console项目</a><br><a href=#%e5%b0%9d%e8%af%95%e6%89%93%e5%bc%80Linux%20CMake%e9%a1%b9%e7%9b%ae><i class=hc-code-working></i>&nbsp; 尝试打开Linux CMake项目</a><br><a href=#Intellisense%e5%9c%a8Linux%20CMake%e9%a1%b9%e7%9b%ae%e4%b8%8b%e7%9a%84%e8%a1%a5%e5%85%a8><i class=hc-code-working></i>&nbsp; Intellisense在Linux CMake项目下的补全</a><br></div></div><div class=widget><h5>近期文章</h5><ul><li><a href=/2018/11/5/rszmfdd.html>人，是怎么废掉的</a><li><a href=/2018/8/25/build-jiri-for-windows.html>Build jiri for Windows</a><li><a href=/2018/8/24/remember-1000-words-a-day.html>一天记忆1000个GRE单词</a><li><a href=/2018/4/16/get-ostep.html>Download and stitch together OSTEP book</a><li><a href=/2018/4/7/gcj2018.html>谷歌代码酱GCJ2018</a><li><a href=/2018/4/5/fast-sorting.html>高性能排序算法</a><li><a href=/2018/2/19/linux-programming-with-vs.html>Visual Studio下开发Linux程序</a><li><a href=/2018/2/11/2018-spring-festival-gala.html>麦迪逊2018狗年春晚</a><li><a href=/2018/1/15/20-years-into-the-world.html>我的前20年</a><li><a href=/2017/12/27/sudoku-in-vim.html>在Vim中愉快地玩数独</a></ul></div><div class=widget><h5>分类</h5><a href=/category/Dark%20Magic.html><i class=hc-albums></i>&nbsp; Dark Magic</a>(1)<br><a href=/category/GRE.html><i class=hc-albums></i>&nbsp; GRE</a>(1)<br><a href=/category/Go.html><i class=hc-albums></i>&nbsp; Go</a>(2)<br><a href=/category/Linux.html><i class=hc-albums></i>&nbsp; Linux</a>(3)<br><a href=/category/Qt.html><i class=hc-albums></i>&nbsp; Qt</a>(1)<br><a href=/category/Rust.html><i class=hc-albums></i>&nbsp; Rust</a>(1)<br><a href=/category/Vim.html><i class=hc-albums></i>&nbsp; Vim</a>(1)<br><a href=/category/%e4%ba%ba%e5%b7%a5%e6%99%ba%e8%83%bd.html><i class=hc-albums></i>&nbsp; 人工智能</a>(1)<br><a href=/category/%e4%ba%ba%e7%94%9f%e9%9a%8f%e7%ac%94.html><i class=hc-albums></i>&nbsp; 人生随笔</a>(2)<br><a href=/category/%e4%bc%9a%e8%ae%ae.html><i class=hc-albums></i>&nbsp; 会议</a>(1)<br><a href=/category/%e5%bc%80%e5%8f%91%e7%8e%af%e5%a2%83.html><i class=hc-albums></i>&nbsp; 开发环境</a>(3)<br><a href=/category/%e6%99%ba%e8%83%bd%e5%ae%b6%e5%ba%ad.html><i class=hc-albums></i>&nbsp; 智能家庭</a>(1)<br><a href=/category/%e6%b7%b1%e5%ba%a6%e5%ad%a6%e4%b9%a0.html><i class=hc-albums></i>&nbsp; 深度学习</a>(2)<br><a href=/category/%e6%b8%b8%e8%ae%b0.html><i class=hc-albums></i>&nbsp; 游记</a>(1)<br><a href=/category/%e7%9b%b8%e5%86%8c.html><i class=hc-albums></i>&nbsp; 相册</a>(3)<br><a href=/category/%e7%ae%97%e6%b3%95.html><i class=hc-albums></i>&nbsp; 算法</a>(5)<br><a href=/category/%e7%bd%91%e7%ab%99%e8%bf%90%e7%bb%b4.html><i class=hc-albums></i>&nbsp; 网站运维</a>(5)<br><a href=/category/%e9%bb%91%e9%ad%94%e6%b3%95.html><i class=hc-albums></i>&nbsp; 黑魔法</a>(3)<br></div><div class=widget><h5>热门标签</h5><div class=tagcloud><a href=/tags/ACM/GCJ.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; ACM/GCJ</a>
<a href=/tags/AlphaGo.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; AlphaGo</a>
<a href=/tags/CNNs.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; CNNs</a>
<a href=/tags/CSSA.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; CSSA</a>
<a href=/tags/Fuchsia.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Fuchsia</a>
<a href=/tags/GRE.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; GRE</a>
<a href=/tags/Go.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Go</a>
<a href=/tags/Israfil.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Israfil</a>
<a href=/tags/Linux.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Linux</a>
<a href=/tags/Lumos.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Lumos</a>
<a href=/tags/PokemonGo.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; PokemonGo</a>
<a href=/tags/Portus.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Portus</a>
<a href=/tags/Rust.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Rust</a>
<a href=/tags/Scrawler.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Scrawler</a>
<a href=/tags/Sudoku.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Sudoku</a>
<a href=/tags/UW-Madison.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; UW-Madison</a>
<a href=/tags/Vim.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Vim</a>
<a href=/tags/Visual%20Studio.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Visual Studio</a>
<a href=/tags/Vocabulary.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; Vocabulary</a>
<a href=/tags/WSL.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; WSL</a>
<a href=/tags/jiri.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; jiri</a>
<a href=/tags/%e4%bc%9a%e8%ae%ae.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 会议</a>
<a href=/tags/%e6%8a%80%e6%9c%af%e6%80%a7%e6%b3%84%e6%84%a4.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 技术性泄愤</a>
<a href=/tags/%e6%97%a0%e7%97%85%e5%91%bb%e5%90%9f.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 无病呻吟</a>
<a href=/tags/%e6%98%8e%e5%b0%bc%e8%8b%8f%e8%be%be.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 明尼苏达</a>
<a href=/tags/%e6%99%ba%e8%83%bd%e5%ae%b6%e5%ba%ad.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 智能家庭</a>
<a href=/tags/%e6%b8%b8%e8%ae%b0.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 游记</a>
<a href=/tags/%e7%88%ac%e8%99%ab.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 爬虫</a>
<a href=/tags/%e8%87%aa%e7%94%b1%e8%bd%af%e4%bb%b6.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 自由软件</a>
<a href=/tags/%e8%bd%ac%e8%bd%bd.html style=font-size:8pt><i class=hc-pricetag></i>&nbsp; 转载</a></div></div></div></div></div></div></section><section id=comment><script src=/js/ddisqus.js></script><section class=grey-bg><div class=container><div id=disqus_thread></div><div id=load-disqus style=text-align:center><button class="btn btn-color" onclick='disqus.boot("l-e-r-space-cn");'>加载/发表评论</button></div><noscript>Please enable JavaScript to view the <a href=https://disqus.com/?ref_noscript rel=nofollow>comments
powered by Disqus.</a></noscript></div></section></section><footer id=footer><div class=footer-widgets><div class=container><div class=row><div class="col-md-3 col-sm-6"><div class=widget><figure class="footer-logo mb-15"><p class=footer-logo-text>L.E.R Space</figure><div class=textwidget><p><img src=/media/misc/uw-crest.svg width=20 alt>
University of Wisconsin - Madison<br>939A Lucky Apartments,<br>777 University Avenue,<br>Madison, WI 53715<p>i+space@rongyi.io<br>+1 (419)-777-9939</div></div></div><div class="col-md-2 col-sm-6"><div class=widget><h5>页面</h5><div class=menu-footer><ul><li><a href=/about.html>关于我</a><li><a href=/contact.html>联系</a><li><a href=/projects.html>软件</a><li><a href=/sheets.html>乐谱分享</a><li><a href=/posts/1>博客</a></ul></div></div></div><div class="col-md-2 col-sm-6"><div class=widget><h5>Meta</h5><div class=menu-footer><ul><li><a href=/feed.xml>RSS 订阅</a><li><a href=/sitemap.xml>网站地图</a><li><a href=/portus.html>Portus 状态</a><li><a href=/license.html>法律信息</a></ul></div></div></div><div class="col-md-5 col-sm-6"><div class=widget><h5>网站信息</h5><div class=menu-footer><p>本站由<b>在下</b>编写的 <a href=/portus.html>Portus Engine 1.3.8</a> 强力驱动<p>部署源 <b>[everette@LER0ever-Desktop-Manjaro]</b><p>托管于 <b>Hostker</b> 和 <b>Netlify</b><p>本站已持续运行<b id=time-dnum>...</b>天<b id=time-hnum>...</b>小时<p>站点内容采用 <a href=https://creativecommons.org/licenses/by-nc-nd/4.0/deed.zh target=_blank>知识共享署名-非商业性使用-禁止演绎 4.0 国际许可协议</a> 进行许可<img style=height:20px src=/media/footer/by-nc-nd.svg><p><a target=_blank href="http://www.beian.gov.cn/portal/registerSystemInfo?recordcode=32050702010247" style=display:inline-block;text-decoration:none;height:20px;line-height:20px><img src=/media/footer/sgwab.png style=float:left>苏公网安备 32050702010247号</a></p><script>
        var now = new Date(); 
        function createtime(){ 
          var grt= new Date("07/25/2013 21:51:00");
          now.setTime(now.getTime()+250); 
          days = (now - grt ) / 1000 / 60 / 60 / 24; dnum = Math.floor(days); 
          hours = (now - grt ) / 1000 / 60 / 60 - (24 * dnum); hnum = Math.floor(hours); 
          document.getElementById("time-dnum").innerHTML = dnum;
          document.getElementById("time-hnum").innerHTML = hnum;
        }
        
        createtime();
      </script></div></div></div></div></div></div><div class=footer-copy><div class=container><div class=row><div class=col-sm-6><ul class=social-list><li class=social-item-linkedin><a target=_blank href=http://www.linkedin.com/in/LER0ever/><i class=hc-linkedin></i></a><li class=social-item-facebook><a target=_blank href=https://www.facebook.com/LER0ever><i class=hc-facebook></i></a><li class=social-item-twitter><a target=_blank href=https://twitter.com/LER0ever><i class=hc-twitter></i></a><li class=social-item-github><a target=_blank href=https://github.com/LER0ever><i class=hc-github></i></a><li class=social-item-telegram><a target=_blank href=https://t.me/LER0ever><i class=hc-paper-plane></i></a></ul></div><div class=col-sm-6><div class=copy-text><p>版权所有 © 2013 - 2019 LER0ever 保留所有权利。</div></div><div id=toTop><i class=hc-arrow-dropup></i></div></div></div></div></footer></div><div class=search-tool style=position:fixed;top:0;bottom:0;left:0;right:0;opacity:.95;background-color:#111;z-index:9999;display:none><input class="form-control search-content" id=search-content style=position:fixed;top:60px placeholder="文章标题 分类 标签 (L.E.R Space 站内搜索)"><div style=position:fixed;top:16px;right:16px><img src=/search/img/close.png id=close-btn></div></div><script src=/js/jquery.js></script><script src=/js/bundle.js></script><script src=/js/SmoothScroll.js></script><script src=/js/highlight.pack.js></script><script>hljs.initHighlightingOnLoad();</script><script src=/search/js/search.js></script><script src=/search/js/bootstrap3-typeahead.min.js></script><script src=/js/main.js></script><script>
  if (navigator.serviceWorker) {
    navigator.serviceWorker.register('/js/sw.js')
      .then(function(registration) {
      }).catch(function (err) {
      });
  }
</script><script>
  (function(){
    var bp = document.createElement('script');
    var curProtocol = window.location.protocol.split(':')[0];
    if (curProtocol === 'https') {
      bp.src = 'https://zz.bdstatic.com/linksubmit/push.js';
    }
    else {
      bp.src = 'http://push.zhanzhang.baidu.com/push.js';
    }
    var s = document.getElementsByTagName("script")[0];
    s.parentNode.insertBefore(bp, s);
  })();
</script><script>
    window.ga=window.ga||function(){(ga.q=ga.q||[]).push(arguments)};ga.l=+new Date;
    ga('create', 'UA-81922310-1', 'auto');
    ga('send', 'pageview');
    </script><script async src=//www.google-analytics.com/analytics.js></script><script>
    var _hmt = _hmt || [];
    (function() {
        var hm = document.createElement("script");
        hm.src = "//hm.baidu.com/hm.js?10782233f36489cdb8181f5e3166973d";
        var s = document.getElementsByTagName("script")[0]; 
        s.parentNode.insertBefore(hm, s);
    })();
    </script><script>_atrk_opts={atrk_acct:"JXtbq1Fx9f207i",domain:"rongyi.blog",dynamic:true};(function(){var as=document.createElement('script');as.type='text/javascript';as.async=true;as.src="https://certify-js.alexametrics.com/atrk.js";var s=document.getElementsByTagName('script')[0];s.parentNode.insertBefore(as,s);})();</script><noscript><img src="https://certify.alexametrics.com/atrk.gif?account=JXtbq1Fx9f207i" style=display:none height=1 width=1 alt></noscript><script src=//instant.page/1.1.0 type=module integrity=sha384-EwBObn5QAxP8f09iemwAJljc+sU+eUXeL9vSBw1eNmVarwhKk2F9vBEpaN9rsrtp></script>